#include <iostream>

using namespace std;

struct human {
	int number;
	String last_name;
	String first_name;
	int age;
	String country;
	String job;
	String hobby;
	String phone_number;
};

template <>
Element<human> *Dynamo<human>::get(const int value)
{
	Element<human> *temp = head;

	while (temp != NULL) {
		if (temp->getData()->number == value) {
			return temp;
		}
		temp = temp->getNext();
	}
	return NULL;
}

template <>
Element<human> *Dynamo<human>::get(const char *str)
{
	Element<human> *temp = head;
	String buf_str(str);

	while (temp != NULL) {
		if (temp->getData()->last_name == buf_str) {
			return temp;
		}
		temp = temp->getNext();
	}
	return NULL;
}

template <>
void Element<human>::show()
{
	if (this == NULL) {
		return;
	}
	cout << ": " << data->number << endl
		  << ": " << data->last_name << endl
		  << ": " << data->first_name << endl
		  << ": " << data->age << endl
		  << ": " << data->country << endl
		  << ": " << data->job << endl
		  << ": " << data->hobby << endl
		  << ": " << data->phone_number << endl;
}

template <>
void Dynamo<human>::show()
{
	Element<human> *temp = head;

	while (temp != NULL) {
		cout << temp->getData()->number << " "
			  << temp->getData()->last_name << " "
			  << temp->getData()->first_name << " "
			  << temp->getData()->age << " "
			  << temp->getData()->country << " "
			  << temp->getData()->job << " "
			  << temp->getData()->hobby << " "
			  << temp->getData()->phone_number << endl;

		temp = temp->getNext();
	}
}

template <>
void Dynamo<human>::sort()
{
	if (head) {
		Element<human> *res = head;
		head = head->getNext();
		res->setNext(NULL);

		while (head) {
			Element<human> *elem = head;
			head = head->getNext();

			if (elem->getData()->number < res->getData()->number) {
				elem->setNext(res);
				res = elem;
			} else {
				Element<human> *p = res;

				while (p->getNext()) {
					if (p->getNext()->getData()->number > elem->getData()->number) {
						break;
					}

					p = p->getNext();
				}

				elem->setNext(p->getNext());
				p->setNext(elem);
			}
		}
		head = res;
	}
}

template <>
void Dynamo<human>::sortByName()
{
	if (head) {
		Element<human> *res = head;
		head = head->getNext();
		res->setNext(NULL);

		while (head) {
			Element<human> *elem = head;
			head = head->getNext();

			if (elem->getData()->last_name < res->getData()->last_name) {
                elem->setNext(res);
				res = elem;
			} else {
				Element<human> *p = res;

				while (p->getNext()) {
					if (p->getNext()->getData()->last_name > elem->getData()->last_name) {
						break;
					}

					p = p->getNext();
				}

				elem->setNext(p->getNext());
				p->setNext(elem);
			}
		}
		head = res;
	}
}
