#include "String.h"

String::String()
{
    s = new char [256];
    s[0] = '\0';
    n = 0;
}

String::String(const char *input_string)
{
    s = new char [256];
    s[0] = '\0';
    n = 0;
    append(input_string);
}

String::String(const String &obj)
{
    s = new char [256];
    s[0] = '\0';
    n = 0;
    append(obj.s);
}

String::~String()
{
    if (s) {
        delete s;
        s = NULL;
    }
}

int String::length()
{
    return n;
}

char String::at(int index)
{
    return s[index];
}

void String::setchar(int index, char symbol)
{
    s[index] = symbol;
}

void String::append(const char *str)
{
    //   str
    int str_len = strlen(str);

    //      
    char *buf = new char [n + str_len + 1];

    // 
    for (int i = 0; i < n; i++) {
        buf[i] = s[i];
    }

    for (int i = n; i < n + str_len; i++) {
        buf[i] = str[i - n];
    }

    n += str_len;
    buf[n] = '\0';

    //        buf
    delete s;
    s = buf;
}

void String::set(const char *str)
{
    int str_len = strlen(str);
    char *buf = new char [str_len + 1];

    // 
    for (int i = 0; i < str_len; i++) {
        buf[i] = str[i];
    }

    n = str_len;
    buf[n] = '\0';

    //        buf
    delete s;
    s = buf;
}

void String::erase(int start_pos, int end_pos)
{
    end_pos++;

    for (int i = 0; s[i] != '\0'; i++) {
        s[start_pos + i] = s[end_pos + i];
    }

    n -= end_pos - start_pos;
    s[n] = '\0';
}

void String::insert(const char *str, int index)
{
    //   str
    int str_len = strlen(str);

    //      
    char *buf = new char [n + str_len + 1];

    // 
    for (int i = 0; i < index; i++) {
        buf[i] = s[i];
    }

    for (int i = 0; i < str_len; i++) {
        buf[i + index] = str[i];
    }

    for (int i = index; i < n; i++) {
        buf[i + str_len] = s[i];
    }

    n += str_len;
    buf[n] = '\0';

    //        buf
    delete s;
    s = buf;
}

char *String::c_str()
{
    return s;
}

int strlen(const char *str)
{
    int len = 0;
    while (str[len] != '\0') {
        len++;
    }
    return len;
}

String& String::operator+(String& str)
{
    String *buf = new String;
    buf->append(s);
    buf->append(str.s);
    return *buf;
}

bool String::operator==(String& str)
{
    if (n != str.n) {
        return false;
    }

    for (int i = 0; i < n; i++) {
        if (s[i] != str.s[i]) {
            return false;
        }
    }
    return true;
}

bool String::operator!=(String& str)
{
    return !(*this == str);
}

bool String::operator<(String& str)
{
    int min_length = n < str.n ? n : str.n;

    for (int i = 0; i < min_length; i++) {
        if (s[i] == str.s[i]) {
            continue;
        }
        return s[i] < str.s[i];
    }
    return n < min_length;
}

bool String::operator>(String& str)
{
    int min_length = n < str.n ? n : str.n;

    for (int i = 0; i < min_length; i++) {
        if (s[i] == str.s[i]) {
            continue;
        }
        return s[i] > str.s[i];
    }
    return n < min_length;
}

istream& operator>>(istream& in, String& str)
{
    in >> str.s;
    OemToChar(str.s, str.s);
    str.n = strlen(str.s);
    return in;
}

ostream& operator<<(ostream& out, String& str)
{
    out << str.s;
    return out;
}

ostream& operator<<(ostream& out, const char *obj)
{
    int len = strlen(obj);
    char *str = new char [len + 1];

    CharToOem(obj, str);

    for (int i = 0; i < len; i++) {
        out << str[i];
    }
    return out;
}
