#include <iostream>
#include <stdio.h>

#define strlen __strlen
#include <windows.h>
#undef strlen

#ifndef STRING_H
#define STRING_H

using namespace std;

class String {
public:
    String();
    String(const char *input_string);
    String(const String &obj);
    ~String();

    int length();
    char at(int index);
    void set(const char *str);
    void setchar(int index, char symbol);
    void append(const char *str);
    void erase(int start_pos, int end_pos);
    void insert(const char *str, int index);
    char *c_str();
    friend int strlen(const char *str);

    String& operator+(String& str);
    bool operator==(String& str);
    bool operator!=(String& str);
    bool operator<(String& str);
    bool operator>(String& str);

    friend istream& operator>>(istream& in, String& str);
    friend ostream& operator<<(ostream& out, String& str);

private:
    char *s;
    int n;
};

ostream& operator<<(ostream& out, const char *obj);

#endif // STRING_H
