#include "String.h"
#include "Dynamo.h"
#include "Human.h"

void backMessage();
void editMessage(Element<human> *current_data, human *input_data);
void inputInteger(const char *name, int *current_value, int *dest_value);
void inputString(const char *name, String *current_value, String *dest_value);
bool isNumber(char *str, int length);

int main()
{
	human elem_array[] = {
		{1, "", "", 62, "", "", "", "79991234567"},
		{2, "", "", 49, "", " ", "", "79991234567"},
		{3, "", "", 53, "", "", "", "19991234567"},
		{6, "", "", 73, "", "", "", "19991234567"},
		{10, "", "", 74, "", "", "", "499991234567"},
		{4, "", "", 60, "", "", "", "339991234567"},
		{7, "", "", 89, "", "", "", "399991234567"},
		{8, "", "", 54, "", "", "", "419991234567"},
		{9, "", "", 66, "", "", "", "3589991234567"},
		{5, " II", "", 88, "", "", "", "449991234567"}
	};

	Dynamo<human> list;

	for (unsigned int i = 0; i < sizeof(elem_array) / sizeof(*elem_array); i++) {
		list.add(elem_array[i]);
	}

	char input[32];
	int input_menu;

	do {
		cout << "      :" << endl;
		cout << "1 -    " << endl;
		cout << "2 -    " << endl;
		cout << "3 -    " << endl;
		cout << "4 -    " << endl;
		cout << "5 -    " << endl;
		cout << "6 -    " << endl;
		cout << "7 -    " << endl;
		cout << "8 -    " << endl;
		cout << "9 -    " << endl;
		cout << "10 -   " << endl;
		cout << "0 - " << endl;

		cout << ": ";

		cin.getline(input, 32);
		input_menu = atoi(input);

		switch (input_menu) {
			case 1:
				{
					int input_number;

					cout << "  : ";
					cin.getline(input, 32);
					input_number = atoi(input);

					Element<human> *input_elem = list.get(input_number);
					if (input_elem == NULL) {
						cout << ":    '" << input_number << "'  " << endl;
					} else {
						input_elem->show();
					}

					backMessage();
				}
				break;
			case 2:
				{
					cout << "  : ";
					cin.getline(input, 32);
					OemToChar(input, input);

					Element<human> *input_elem = list.get(input);
					if (input_elem == NULL) {
						cout << ":    '" << input << "'  " << endl;
					} else {
						input_elem->show();
					}

					backMessage();
				}
				break;
			case 3:
				{
					int input_number;

					cout << "  : ";
					cin.getline(input, 32);
					input_number = atoi(input);

					Element<human> *input_elem = list.get(input_number);
					if (input_elem == NULL) {
						cout << ":    '" << input_number << "'  " << endl;
					} else {
						list.remove(input_elem);
						cout << " " << endl;
					}

					backMessage();
				}
				break;
			case 4:
				{
					cout << "  : ";
					cin.getline(input, 32);
					OemToChar(input, input);

					Element<human> *input_elem = list.get(input);
					if (input_elem == NULL) {
						cout << ":    '" << input << "'  " << endl;
					} else {
						list.remove(input_elem);
						cout << " " << endl;
					}

					backMessage();
				}
				break;
			case 5:
				{
					int input_number;

					cout << "  : ";
					cin.getline(input, 32);
					input_number = atoi(input);

					Element<human> *input_elem = list.get(input_number);
					if (input_elem == NULL) {
						cout << ":    '" << input_number << "'  " << endl;
					} else {
						human edit_elem;
						editMessage(input_elem, &edit_elem);

						list.edit(input_elem, edit_elem);

						cout << " " << endl;
					}

					backMessage();
				}
				break;
			case 6:
				{
					cout << "  : ";
					cin.getline(input, 32);
					OemToChar(input, input);

					Element<human> *input_elem = list.get(input);
					if (input_elem == NULL) {
						cout << ":    '" << input << "'  " << endl;
					} else {
						human edit_elem;
						editMessage(input_elem, &edit_elem);

						list.edit(input_elem, edit_elem);

						cout << " " << endl;
					}

					backMessage();
				}
				break;
			case 7:
				{
					human input_elem;

					editMessage(NULL, &input_elem);

					list.add(input_elem);

					cout << "  " << endl;
					backMessage();
				}
				break;
			case 8:
				list.sort();

				cout << "   " << endl;
				backMessage();
				break;
			case 9:
				list.sortByName();

				cout << "   " << endl;
				backMessage();
				break;
			case 10:
				list.show();
				backMessage();
				break;
		}
	} while (input_menu != 0);
	return 0;
}

void backMessage()
{
	cout << endl << "     " << endl;
	char input[32];
	cin.getline(input, 32);
}

void editMessage(Element<human> *current_data, human *input_data)
{
	if (current_data == NULL) {
		inputInteger("", NULL, &input_data->number);
		inputString("", NULL, &input_data->last_name);
		inputString("", NULL, &input_data->first_name);
		inputInteger("", NULL, &input_data->age);
		inputString("", NULL, &input_data->country);
		inputString("", NULL, &input_data->job);
		inputString("", NULL, &input_data->hobby);
		inputString("", NULL, &input_data->phone_number);
	} else {
		inputInteger("", &current_data->getData()->number, &input_data->number);
		inputString("", &current_data->getData()->last_name, &input_data->last_name);
		inputString("", &current_data->getData()->first_name, &input_data->first_name);
		inputInteger("", &current_data->getData()->age, &input_data->age);
		inputString("", &current_data->getData()->country, &input_data->country);
		inputString("", &current_data->getData()->job, &input_data->job);
		inputString("", &current_data->getData()->hobby, &input_data->hobby);
		inputString("", &current_data->getData()->phone_number, &input_data->phone_number);
	}
}

void inputInteger(const char *name, int *current_value, int *dest_value)
{
	char input[32];

	do {
		if (current_value == NULL) {
			cout << " " << name << ": ";
		} else {
			cout << " " << name << " [" << *current_value << "]: ";
		}
		cin.getline(input, 32);

		if (strlen(input) == 0 && current_value != NULL) {
			*dest_value = *current_value;
			return;
		}
	} while (!isNumber(input, 32));

	*dest_value = atoi(input);
}

void inputString(const char *name, String *current_value, String *dest_value)
{
	char input[32];

	if (current_value == NULL) {
		do {
			cout << " " << name << ": ";
			cin.getline(input, 32);
            OemToChar(input, input);

			dest_value->set(input);
		} while (strlen(input) == 0);
	} else {
		cout << " " << name << " [" << *current_value << "]: ";
		cin.getline(input, 32);
        OemToChar(input, input);

		if (strlen(input) == 0) {
			*dest_value = *current_value;
		} else {
			dest_value->set(input);
		}
	}
}

bool isNumber(char *str, int length)
{
	return isdigit(str[0]);
}
